/*
 * ActtreeinterventionbydateBehavior.java
 * Copyright (c) 2012, W4.
 * All rights reserved.
 */

package GestionInterventions.behavior;

import leon.app.behavior.LyTreeBehavior;
import leon.control.LyTreeController;
import leon.data.LyObject;
import leon.data.LyObjectList;
import leon.data.LySimpleObjectList;
import leon.info.LyClassInfo;
import leon.info.LyFilter;
import leon.info.LyFilterExpression;
import leon.info.LyFilterExpression.Condition;
import leon.view.LyTreeNode;
import GestionInterventions.src.GESTIONINTERVENTIONS;
import GestionInterventions.src.Interval;

/**
 * This interface defines the methods to implement in order to modify the default behavior of a tree
 * controller.
 *
 * @author  Lyria S.A.
 * @version $Id: LyTreeBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyTreeController
 */
public class ActtreeinterventionbydateBehavior extends LyTreeBehavior
{
	/**
	 * Default Constructor
	 */
	public ActtreeinterventionbydateBehavior()
	{
	}
	
	@Override
	public LyObjectList getSons(LyObject parentNodeObject, LyTreeNode treeNode,
			String level, LyTreeController controller) {
		// TODO Auto-generated method stub
		LyObjectList sons = super.getSons(parentNodeObject, treeNode, level, controller);
		
		LyObject treeNodeObject = controller.getObjectFromTreeNodeId(treeNode.getId());
		if(treeNodeObject != null && treeNodeObject.getClassInfo().equals(controller.getClassInfo(GESTIONINTERVENTIONS.CLS_YEAR_CLASS))){
			LyObjectList sonsWithContent = new LySimpleObjectList();
			LyClassInfo interventionClassInfo = controller.getClassInfo(GESTIONINTERVENTIONS.CLS_INTERVENTION_CLASS);
			for(int i = 0; i < sons.getSize(); i++){	
				String monthFormated = sons.getObject(i).getName();				
				Interval interval = new Interval(monthFormated);
				
			
				LyFilter filter = new LyFilter();
				LyFilterExpression filterExpressionGT = new LyFilterExpression(interventionClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_INTERVENTION_DATE_INTERVENTION), Condition.GREATER_OR_EQUALS, interval.getStartDate());
				LyFilterExpression filterExpressionLT = new LyFilterExpression(interventionClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_INTERVENTION_DATE_INTERVENTION), Condition.LOWER_THAN, interval.getEndDate());
				filter.addElement(filterExpressionGT);
				filter.addElement(filterExpressionLT);
				int matchingMonths = interventionClassInfo.getObjectSource().getSize(filter);
				if(matchingMonths > 0){
					sonsWithContent.addList(new LySimpleObjectList(sons.getObject(i)));
				}
			}
			return sonsWithContent;
		}
		
		return sons;
	}
	
	

}