SET SQL DIALECT 3;
SET NAMES utf8;
CREATE DATABASE '/var/lib/firebird/2.5/data/database/plananimation.fdb' USER 'SYSDBA' PASSWORD 'masterkey' PAGE_SIZE 16384 DEFAULT CHARACTER SET utf8;
CONNECT '/var/lib/firebird/2.5/data/database/plananimation.fdb' USER 'SYSDBA' PASSWORD 'masterkey';
SET SQL DIALECT 3;
SET NAMES utf8;
CREATE TABLE planAnimationAnimation(
  ANPLACEHOLDER INTEGERINTEGER  NOT NULL  ,
  ANCODE INTEGERINTEGER    ,
  ANBRAND INTEGERINTEGER  NOT NULL  ,
  ANCOMPUTEDPRICES DECIMAL(18,2)  NOT NULL  ,
  ANNEGOTIATEDPRICES DECIMAL(18,2)  NOT NULL  ,
  ANCOMMENTS VARCHAR(30)  NOT NULL  ,
  ANAXIS INTEGERINTEGER  NOT NULL  ,
  ANCONCERNEDSTORES VARCHAR(1)  NOT NULL    ,
  PRIMARY KEY(ANCODE));


CREATE GENERATOR planAnimationAnimation_ANCODE;

SET TERM !; 
CREATE TRIGGER AINC_planAnimationAnimation FOR planAnimationAnimation BEFORE INSERT  
AS
BEGIN 
  IF (NEW.ANCODE IS NULL) THEN 
    NEW.ANCODE = GEN_ID(planAnimationAnimation_ANCODE, 1); 
END! 
SET TERM ;! 

CREATE TABLE planAnimationPlaceholder(
  PHCOD INTEGERINTEGER    ,
  PHNAME VARCHAR(30)  NOT NULL  ,
  PHDETAILS VARCHAR(30)  NOT NULL  ,
  PHPRICE INTEGERINTEGER  NOT NULL  ,
  PHMULTIBRAND INTEGERINTEGER  NOT NULL  ,
  PHISUNIQUE VARCHAR(1)  NOT NULL    ,
  PRIMARY KEY(PHCOD));


CREATE GENERATOR planAnimationPlaceholder_PHCOD;

SET TERM !; 
CREATE TRIGGER AINC_planAnimationPlaceholder FOR planAnimationPlaceholder BEFORE INSERT  
AS
BEGIN 
  IF (NEW.PHCOD IS NULL) THEN 
    NEW.PHCOD = GEN_ID(planAnimationPlaceholder_PHCOD, 1); 
END! 
SET TERM ;! 

CREATE TABLE planAnimationBrand(
  BRCODE INTEGERINTEGER    ,
  BRNAME VARCHAR(30)  NOT NULL  ,
  BRMARKET INTEGERINTEGER  NOT NULL  ,
  BRCUSTOMERCODE VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(BRCODE));


CREATE GENERATOR planAnimationBrand_BRCODE;

SET TERM !; 
CREATE TRIGGER AINC_planAnimationBrand FOR planAnimationBrand BEFORE INSERT  
AS
BEGIN 
  IF (NEW.BRCODE IS NULL) THEN 
    NEW.BRCODE = GEN_ID(planAnimationBrand_BRCODE, 1); 
END! 
SET TERM ;! 

CREATE TABLE planAnimationMarket(
  planAnimationMarketId INTEGERINTEGER    ,
  planAnimationMarketName VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(planAnimationMarketId));
CREATE TABLE planAnimationAxis(
  AXCODE INTEGERINTEGER    ,
  AXNAME VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(AXCODE));


CREATE GENERATOR planAnimationAxis_AXCODE;

SET TERM !; 
CREATE TRIGGER AINC_planAnimationAxis FOR planAnimationAxis BEFORE INSERT  
AS
BEGIN 
  IF (NEW.AXCODE IS NULL) THEN 
    NEW.AXCODE = GEN_ID(planAnimationAxis_AXCODE, 1); 
END! 
SET TERM ;! 

CREATE TABLE planAnimationArea(
  planAnimationAreaId INTEGERINTEGER    ,
  planAnimationAreaName VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(planAnimationAreaId));
CREATE TABLE planAnimationMegaplan(
  planAnimationMegaplanId INTEGERINTEGER    ,
  planAnimationMegaplanName VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(planAnimationMegaplanId));
CREATE TABLE planAnimationMetaplanNature(
  planAnimationMetaplanNatureId INTEGERINTEGER    ,
  planAnimationMetaplanNatureName VARCHAR(30)  NOT NULL    ,
  PRIMARY KEY(planAnimationMetaplanNatureId));
COMMIT;

